## frama-c 20110201+carbon+dfsg

=== Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2011                                               #
#    CEA   (Commissariat  l'nergie atomique et aux nergies            #
#           alternatives)                                                #
#    INRIA (Institut National de Recherche en Informatique et en         #
#           Automatique)                                                 #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version v2.1                #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# This file is the main makefile of Frama-C.

FRAMAC_SRC=.
MAKECONFIG_DIR=share

include share/Makefile.common

###################
# Frama-C Version #
###################

VERSION=$(shell $(SED) -e 's/\\(.*\\)/\\1/' VERSION)

ifeq ($(findstring +dev,$(VERSION)),+dev)
DEVELOPMENT=yes
else
DEVELOPMENT=no
endif

###########################
# Global plugin variables #
###########################

# the directory where compiled plugin files are stored
PLUGIN_LIB_DIR	= lib/plugins
PLUGIN_GUI_LIB_DIR= lib/plugins/gui

# the directory where the other Makefiles are
FRAMAC_SHARE	= share

# set it to yes to tell Makefile.dynamic than we come from here
FRAMAC_MAKE	=yes

# Shared lists between Makefile.plugin and Makefile :
# initialized them as "simply extended variables" (with :=)
# for a correct behavior of += (see section 6.6 of GNU Make manual)
PLUGIN_LIST	:=
PLUGIN_DYN_EXISTS:="no"
PLUGIN_DYN_LIST :=
PLUGIN_CMO_LIST	:=
PLUGIN_CMX_LIST	:=
PLUGIN_DYN_CMO_LIST :=
PLUGIN_DYN_CMX_LIST :=
PLUGIN_INTERNAL_CMO_LIST:=
PLUGIN_INTERNAL_CMX_LIST:=
PLUGIN_DEP_GUI_CMO_LIST:=
PLUGIN_DEP_GUI_CMX_LIST:=
PLUGIN_GUI_CMO_LIST:=
PLUGIN_GUI_CMX_LIST:=
PLUGIN_DYN_DEP_GUI_CMO_LIST:=
PLUGIN_DYN_DEP_GUI_CMX_LIST:=
PLUGIN_DYN_GUI_CMO_LIST :=
PLUGIN_DYN_GUI_CMX_LIST :=
PLUGIN_TYPES_CMO_LIST :=
PLUGIN_TYPES_CMX_LIST :=
PLUGIN_DEP_LIST:=
PLUGIN_DOC_LIST :=
PLUGIN_DOC_DIRS :=
PLUGIN_DISTRIBUTED_LIST:=
PLUGIN_DIST_TARGET_LIST:=
PLUGIN_DIST_DOC_LIST:=
PLUGIN_BIN_DOC_LIST:=
PLUGIN_DIST_EXTERNAL_LIST:=
PLUGIN_TESTS_LIST:=
PLUGIN_DISTRIBUTED_NAME_LIST:=

###############################
# Additional global variables #
###############################

# put here any config option for the binary distribution outside of
# plugins
CONFIG_DISTRIB_BIN:=

# additional compilation targets for 'make all'.
# cannot be delayed after 'make all'
EXTRAS	= ptests

# Directories containing some source code
SRC_DIRS= ptests $(PLUGIN_LIB_DIR)

# Directory containing source code documentation
DOC_DIR	= doc/code

# Source files to document
MODULES_TODOC=

# Directories containing some source code
SRC_DIRS+= $(FRAMAC_SRC_DIRS)

# Directories to include when compiling
INCLUDES=$(addprefix -I , $(FRAMAC_SRC_DIRS)) -I $(PLUGIN_LIB_DIR) -I lib

# Directories to include for ocamldep
INCLUDES_FOR_OCAMLDEP= $(patsubst +%,.,$(INCLUDES) $(GUI_INCLUDES))

# Ocamldep flags
DEP_FLAGS= $(INCLUDES_FOR_OCAMLDEP)

# Files for which dependencies are computed
FILES_FOR_OCAMLDEP+=$(PLUGIN_LIB_DIR)/*.mli \
		$(addsuffix /*.mli, $(UNPACKED_DIRS)) \
		$(addsuffix /*.ml, $(UNPACKED_DIRS))

# Flags to use by ocamlc and ocamlopt
ifeq ($(DEVELOPMENT),yes)
ifeq ($(HAS_OCAML312),yes)
DEV_FLAGS=$(FLAGS) -warn-error +a
else
DEV_FLAGS=$(FLAGS) -warn-error A
endif
else
DEV_FLAGS=$(FLAGS)
endif

BFLAGS	= $(DEV_FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_BYTE) \
	  $(OCAMLVIZ_COMPILER_BYTE)
OFLAGS	= $(DEV_FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_OPT) \
	  $(GPROFOPT) $(OCAMLVIZ_COMPILER_OPT)

BLINKFLAGS = $(BFLAGS) -linkall -custom
OLINKFLAGS = $(OFLAGS) -linkall

# Libraries generated by Frama-C
GEN_BYTE_LIBS=
GEN_OPT_LIBS=

# Libraries used in Frama-C
BYTE_LIBS = nums.cma unix.cma bigarray.cma str.cma dynlink.cma \
	$(GEN_BYTE_LIBS)
OPT_LIBS = nums.cmxa unix.cmxa bigarray.cmxa str.cmxa

ifeq ("$(NATIVE_DYNLINK)","yes")
OPT_LIBS+= dynlink.cmxa
endif

OPT_LIBS+= $(GEN_OPT_LIBS)

ICONS:=  $(addprefix share/, \
		frama-c.ico frama-c.gif left.png right.png \
		relies_on_hyp.png failed.png maybe.png attach.png \
		check.png \
	)

# Kernel files to be included in the distribution.
# Plug-ins should use PLUGIN_DISTRIB_EXTERNAL if they export something else
# than *.ml* files in their directory.
# NB: configure for the distribution is generated in the distrib directory
# itself, rather than copied: otherwise, it could include references to
# non-distributed plug-ins.
DISTRIB_FILES:=cil/*/*.ml* cil/src/*/*.ml* cil/*/*.in cil/LICENSE	\
      cil/CHANGES cil/doc/*.html cil/doc/*.tex cil/doc/*.gif		\
      share/frama-c.WIN32.rc share/frama-c.Unix.rc			\
      $(ICONS)								\
      man/frama-c.1 cil/doc/*.pdf cil/doc/api/*.html			\
      cil/doc/examples/*.txt doc/manuals/*.pdf doc/README		\
      doc/code/*.ml* doc/code/*.css doc/code/*.txt			\
      doc/code/toc_head.htm doc/code/toc_tail.htm			\
      tests/*/*.c tests/*/*.h tests/*/*.ml				\
      ptests/*.ml* configure.in Makefile share/Makefile.kernel		\
      share/Makefile.plugin share/Makefile.dynamic			\
      share/Makefile.dynamic_config.internal				\
      share/Makefile.dynamic_config.external Changelog config.h.in	\
      VERSION $(filter-out CVS,licenses/*) share/*.c share/*.h		\
      share/libc/*.c share/libc/*.h share/libc/sys/*.h			\
      share/libc/netinet/*.h share/acsl.el 				\
      share/configure.ac share/Makefile.config.in			\
      share/Makefile.common share/Makefile.plugin			\
      share/Makefile.dynamic		                                \
      share/Makefile.dynamic_config.external				\
      share/Makefile.dynamic_config.internal             		\
      $(filter-out %kui%,src/kernel/*.ml*)		                \
      external/hptmap.ml* external/unmarshal*.ml*			\
      src/ai/*.ml* src/buckx/*.ml* src/buckx/*.c src/gui/*.ml*		\
      src/lib/*.ml* src/logic/*.ml* src/memory_state/*.ml*		\
      src/misc/*.ml* src/project/*.ml* src/toplevel/*.ml*		\
      src/type/*.ml* bin/sed_get_make_major bin/sed_get_make_minor	\
      bin/sed_inplace INSTALL INSTALL_WITH_WHY .make-clean		\
      .make-clean-stamp .make-ocamlgraph-stamp

################
# Main targets #
################

ifneq ($(ENABLE_GUI),no)
ifeq ($(HAS_LABLGTK),yes)
EXTRAS	+= gui
endif
endif

all:: byte $(OCAMLBEST) $(EXTRAS)

.PHONY: top opt byte dist bdist archclean rebuild
top: bin/toplevel.top$(EXE)

byte:: bin/toplevel.byte$(EXE) \
      share/Makefile.dynamic_config share/Makefile.kernel
	$(MAKE) install-kernel-byte FRAMAC_LIBDIR=lib/fc

opt:: bin/toplevel.opt$(EXE) \
     share/Makefile.dynamic_config share/Makefile.kernel
	$(MAKE) install-kernel-opt FRAMAC_LIBDIR=lib/fc

dist: clean
	$(QUIET_MAKE) OPTIM="-unsafe -noassert" DEBUG="" all

bdist: clean
	$(QUIET_MAKE) OPTIM="-unsafe -noassert" DEBUG="" byte

ifneq ("$(OCAMLGRAPH_LOCAL)","")
archclean: clean
	$(MAKE) -C $(OCAMLGRAPH_LOCAL) distclean
	cd $(OCAMLGRAPH_LOCAL) ; ./configure

rebuild: archclean
	$(MAKE) -C $(OCAMLGRAPH_LOCAL)
	$(QUIET_MAKE) all
else
archclean: clean

rebuild: archclean
	$(QUIET_MAKE) all
endif

############
# Coverage #
############

USE_COVERAGE_TOOL=no
ifeq ($(USE_COVERAGE_TOOL),yes)
COVERAGE_PATH=.
COVERAGE_PREPRO=camlp4o -no_quot -filter $(COVERAGE_PATH)/coverage_filter.cmo
COVERAGE_COMPILER_BYTE=-I $(COVERAGE_PATH) -pp "$(COVERAGE_PREPRO)"
COVERAGE_COMPILER_OPT=-I $(COVERAGE_PATH) -pp "$(COVERAGE_PREPRO)"
COVERAGE_LIB_BYTE=coverage.cma
COVERAGE_LIB_OPT=coverage.cmxa
endif

INCLUDES+=$(COVERAGE_COMPILER_BYTE)
GEN_BYTE_LIBS+=$(COVERAGE_LIB_BYTE)
GEN_OPT_LIBS+=$(COVERAGE_LIB_OPT)
SRC_DIRS+=$(COVERAGE_PATH)

########################
# Ocamlviz (profiling) #
########################

# To use OCamlviz you need to fix its makefile :-(
# In $(OCAMLVIZ_PATH)/Makefile.in change the line
# OCAMLVIZCMO = $(PROTOCOLCMO) src/monitor_impl.cmo src/ocamlviz.cmo src/ocamlviz_threads.cmo
# into
# OCAMLVIZCMO = $(PROTOCOLCMO) src/monitor_impl.cmo src/ocamlviz.cmo
# and
# cp -f src/ocamlviz.mli src/ocamlviz.cmi src/ocamlviz_threads.cmi $(OCAMLLIB)
# into
# cp -f src/ocamlviz.mli src/ocamlviz.cmi $(OCAMLLIB)
#
# Then run "./configure && make && make install" in $(OCAMLVIZ_PATH)
# Only one instance of Frama-C can be launched at a time when Ocamlviz is on.
USE_OCAMLVIZ_TOOL=no
ifeq ($(USE_OCAMLVIZ_TOOL),yes)
OCAMLVIZ_PATH=~/src/ocamlviz
OCAMLVIZ_COMPILER_BYTE=-I $(OCAMLVIZ_PATH)/src # -pp "camlp4 pa_o.cmo str.cma $(OCAMLVIZ_PATH)/camlp4/pa_ocamlviz.cmo pr_o.cmo"
# Seems really broken and generates fatal warnings
OCAMLVIZ_COMPILER_OPT=-I $(OCAMLVIZ_PATH)/src
OCAMLVIZ_LIB_BYTE=~/lib/ocaml/libocamlviz.cma
OCAMLVIZ_LIB_OPT=~/lib/ocaml/libocamlviz.cmxa
endif

BYTE_LIBS+=$(OCAMLVIZ_LIB_BYTE)
OPT_LIBS+=$(OCAMLVIZ_LIB_OPT)

##############
# Ocamlgraph #
##############

ifneq ("$(OCAMLGRAPH_LOCAL)","")

lib/graph.cmi: .make-ocamlgraph $(wildcard $(OCAMLGRAPH_LOCAL)/src/*.ml*) \
		$(OCAMLGRAPH_LOCAL)/Makefile
	$(PRINT_BUILD) ocamlgraph
	$(MAKE) -C $(OCAMLGRAPH_LOCAL)
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@

lib/graph.cmo: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@

lib/graph.cmx: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@

lib/graph.o: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@

GENERATED+= lib/graph.cmo lib/graph.cmi
ifneq ($(OCAMLOPT),no)
GENERATED+= lib/graph.cmx lib/graph.o
endif

GRAPH_BYTE_LIBS=lib/graph.cmo
GRAPH_OPT_LIBS=lib/graph.cmx
GEN_BYTE_LIBS+=$(GRAPH_BYTE_LIBS)
GEN_OPT_LIBS+=$(GRAPH_OPT_LIBS)

.PRECIOUS: .cmo .cmi .cmx .o .cmxa .cma

# viewgraph and  dgraph (included in ocamlgraph)
ifeq ($(HAS_GNOMECANVAS),yes)

lib/viewgraph.cmi: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@

lib/viewgraph.cmo: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@

lib/viewgraph.cmx: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@

lib/viewgraph.o: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@

lib/dgraph.cmi: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@

lib/dgraph.cmo: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@

lib/dgraph.cmx: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@

lib/dgraph.o: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@

GRAPH_GUICMO= lib/dgraph.cmo lib/viewgraph.cmo
GRAPH_GUICMI= $(GRAPH_GUICMO:.cmo=.cmi)
GRAPH_GUICMX= $(GRAPH_GUICMO:.cmo=.cmx)
GRAPH_GUIO=  $(GRAPH_GUICMO:.cmo=.o)
GENERATED+= $(GRAPH_GUICMI) $(GRAPH_GUICMO)
ifneq ($(OCAMLOPT),no)
GENERATED+= $(GRAPH_GUICMX) $(GRAPH_GUIO)
endif

GEN_BYTE_GUI_LIBS+=$(GRAPH_GUICMO)
GEN_OPT_GUI_LIBS+=$(GRAPH_GUICMX)

=== debian/changelog ===
frama-c (20110201+carbon+dfsg-2build2) oneiric; urgency=low

  * No-change rebuild for new lablgtk ABI 

 -- Iain Lane <laney@debian.org>  Sat, 24 Sep 2011 09:26:39 +0100

frama-c (20110201+carbon+dfsg-2build1) oneiric; urgency=low

  * Rebuild to pick up ocaml fixes on armel.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 24 Aug 2011 16:40:54 -0600

frama-c (20110201+carbon+dfsg-2) unstable; urgency=low

  * Add "-I +ocamlgraph" to DYN_{O,B}LINKFLAGS, needed for plugins to link.
    - add 0003-Add-ocamlgraph-to-DYN_-O-B-LINKFLAGS.patch
    - add libocamlgraph-ocaml-dev to frama-c-base's runtime dependencies.

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 25 Apr 2011 12:03:31 +0200

frama-c (20110201+carbon+dfsg-1) unstable; urgency=low

  * New upstream release:
    - Update copyright file.
    - Remove all patches, integrated by upstream.
    - Add patches:
      + 0001-Value-Analysis-Carbon-patchlevel-1.patch
      + 0002-Fix-for-issue-727.patch
  * Fix Categories field in frama-c.desktop (Closes: #610432) (LP: #613853).
  * No need to exclude custom bytecode binaries when running dh_strip.
    (thanks to patch applied in OCaml >= 3.12.0-5)

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 23 Apr 2011 18:47:13 +0200

=== debian/control ===
Source: frama-c
Section: devel
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Mehdi Dogguy <mehdi@debian.org>
Build-Depends:
 debhelper (>= 7.0.50~),
 ocaml-nox (>= 3.12.0~),
 ocaml-best-compilers,
 dh-ocaml (>= 0.9~),
 graphviz,
 libocamlgraph-viewer-ocaml-dev (>> 1.4~),
 liblablgtk2-gnome-ocaml-dev (>= 2.14.0+dfsg-2~),
 liblablgtksourceview2-ocaml-dev (>= 2.14.0+dfsg-2~)
Standards-Version: 3.9.0
Homepage: http://frama-c.com/
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/frama-c.git
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/frama-c.git

Package: frama-c
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 frama-c-base (= ${binary:Version}),
 graphviz,
 emacs | emacsen
Recommends:
 why (>= 2.19+dfsg-2),
Description: Framework for source code analysis of software written in C
 Frama-C is a framework dedicated to the analysis of the source code
 of software written in C.
 .
 Frama-C gathers several static analysis techniques in a single
 collaborative framework. The collaborative approach of Frama-C allows
 static analyzers to build upon the results already computed by other
 analyzers in the framework. Thanks to this approach, Frama-C provides
 sophisticated tools, such as a slicer and dependency analysis.
 .
 It can be used to:
   * Validate the source code formally
   * Look for potential runtime errors
   * Audit or review it
   * Reverse engineer it to understand its structure
   * Generate formal documentation
 .
 This package provides the graphical user interface of Frama-c and depends
 on frama-c-base.

Package: frama-c-base
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 libocamlgraph-ocaml-dev,
 gcc,
Recommends:
 alt-ergo,
 libwhy-coq
Replaces: frama-c (<< 20090902+beryllium+dfsg-1)
Breaks: frama-c (<< 20090902+beryllium+dfsg-1)
Description: Framework for C source code analysis (without gui)
 Frama-C is a framework dedicated to the analysis of the source code
 of software written in C.
 .
 Frama-C gathers several static analysis techniques in a single
 collaborative framework. The collaborative approach of Frama-C allows
 static analyzers to build upon the results already computed by other
 analyzers in the framework. Thanks to this approach, Frama-C provides
 sophisticated tools, such as a slicer and dependency analysis.
 .
 It can be used to:
   * Validate the source code formally
   * Look for potential runtime errors
   * Audit or review it
   * Reverse engineer it to understand its structure
   * Generate formal documentation
 .
 This package provides the library of Frama-c which is useful to build
 plugins for Frama-c and the command-line tools.

## frama-c 20111001%2bnitrogen%2bdfsg

=== debian/control ===
--- 
+++ 
@@ -9,10 +9,10 @@
  ocaml-best-compilers,
  dh-ocaml (>= 0.9~),
  graphviz,
- libocamlgraph-viewer-ocaml-dev (>> 1.4~),
+ libocamlgraph-viewer-ocaml-dev (>> 1.8~),
  liblablgtk2-gnome-ocaml-dev (>= 2.14.0+dfsg-2~),
  liblablgtksourceview2-ocaml-dev (>= 2.14.0+dfsg-2~)
-Standards-Version: 3.9.0
+Standards-Version: 3.9.2
 Homepage: http://frama-c.com/
 Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/frama-c.git
 Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/frama-c.git

## frama-c 20111001+nitrogen+dfsg

=== Makefile ===
--- 
+++ 
@@ -138,12 +138,15 @@
 endif
 
 BFLAGS	= $(DEV_FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_BYTE) \
-	  $(OCAMLVIZ_COMPILER_BYTE)
+	  $(OCAMLVIZ_COMPILER_BYTE) $(OUNIT_COMPILER_BYTE)
 OFLAGS	= $(DEV_FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_OPT) \
-	  $(GPROFOPT) $(OCAMLVIZ_COMPILER_OPT)
+	  $(GPROFOPT) $(OCAMLVIZ_COMPILER_OPT) $(OUNIT_COMPILER_OPT) -compact
 
 BLINKFLAGS = $(BFLAGS) -linkall -custom
 OLINKFLAGS = $(OFLAGS) -linkall
+
+DOC_FLAGS= -colorize-code -stars -inv-merge-ml-mli -m A -hide-warnings \
+	$(INCLUDES) $(GUI_INCLUDES)
 
 # Libraries generated by Frama-C
 GEN_BYTE_LIBS=
@@ -154,17 +157,48 @@
 	$(GEN_BYTE_LIBS)
 OPT_LIBS = nums.cmxa unix.cmxa bigarray.cmxa str.cmxa
 
+# For using Zarith:
+ifeq ($(HAS_ZARITH),yes)
+#ZARITH_LINK = -cclib -L/usr/local/Frama-C/macports/lib
+#ZARITH_INC = -I /home/cuoq/zarith
+BYTE_LIBS+= zarith.cma $(ZARITH_LINK)
+OPT_LIBS+= zarith.cmxa $(ZARITH_LINK)
+INCLUDES+= $(ZARITH_INC)
+src/lib/my_bigint.ml: src/lib/my_bigint.ml.zarith
+	$(PRINT_CP) $@
+	$(CP) $< $@
+	$(CHMOD_RO) $@
+else
+src/lib/my_bigint.ml: src/lib/my_bigint.ml.bigint
+	$(PRINT_CP) $@
+	$(CP) $< $@
+	$(CHMOD_RO) $@
+endif
+GENERATED += src/lib/my_bigint.ml
+DISTRIB_FILES+= src/lib/my_bigint.ml.zarith src/lib/my_bigint.ml.bigint
+
 ifeq ("$(NATIVE_DYNLINK)","yes")
 OPT_LIBS+= dynlink.cmxa
 endif
 
 OPT_LIBS+= $(GEN_OPT_LIBS)
 
-ICONS:=  $(addprefix share/, \
+ICONS:= $(addprefix share/, \
 		frama-c.ico frama-c.gif left.png right.png \
-		relies_on_hyp.png failed.png maybe.png attach.png \
-		check.png \
-	)
+		failed.png maybe.png check.png unmark.png )
+
+FEEDBACK_ICONS:= $(addprefix share/feedback/, \
+		never_tried.png \
+		unknown.png \
+		surely_valid.png \
+		surely_invalid.png \
+		considered_valid.png \
+		valid_under_hyp.png \
+		invalid_under_hyp.png \
+		invalid_but_dead.png \
+		unknown_but_dead.png \
+		valid_but_dead.png \
+		inconsistent.png )
 
 # Kernel files to be included in the distribution.
 # Plug-ins should use PLUGIN_DISTRIB_EXTERNAL if they export something else
@@ -172,35 +206,42 @@
 # NB: configure for the distribution is generated in the distrib directory
 # itself, rather than copied: otherwise, it could include references to
 # non-distributed plug-ins.
-DISTRIB_FILES:=cil/*/*.ml* cil/src/*/*.ml* cil/*/*.in cil/LICENSE	\
-      cil/CHANGES cil/doc/*.html cil/doc/*.tex cil/doc/*.gif		\
-      share/frama-c.WIN32.rc share/frama-c.Unix.rc			\
-      $(ICONS)								\
-      man/frama-c.1 cil/doc/*.pdf cil/doc/api/*.html			\
-      cil/doc/examples/*.txt doc/manuals/*.pdf doc/README		\
-      doc/code/*.ml* doc/code/*.css doc/code/*.txt			\
-      doc/code/toc_head.htm doc/code/toc_tail.htm			\
-      tests/*/*.c tests/*/*.h tests/*/*.ml				\
+DISTRIB_FILES:=cil/*/*.ml* cil/src/*/*.ml* cil/*/*.in			\
+      share/frama-c.WIN32.rc share/frama-c.Unix.rc                      \
+      $(ICONS) $(FEEDBACK_ICONS)			 		\
+      man/frama-c.1 doc/manuals/*.pdf doc/README doc/code/*.ml*		\
+      doc/code/*.css doc/code/intro_plugin.txt				\
+      doc/code/intro_kernel_plugin.txt doc/code/intro_occurrence.txt	\
+      doc/code/intro_pdg.txt doc/code/intro_scope.txt			\
+      doc/code/intro_slicing.txt doc/code/intro_sparecode.txt		\
+      doc/code/intro_wp.txt doc/code/toc_head.htm			\
+      doc/code/toc_tail.htm                                             \
+      tests/*/*.c tests/*/*.i tests/*/*.h tests/*/*.ml	                \
       ptests/*.ml* configure.in Makefile share/Makefile.kernel		\
       share/Makefile.plugin share/Makefile.dynamic			\
       share/Makefile.dynamic_config.internal				\
       share/Makefile.dynamic_config.external Changelog config.h.in	\
-      VERSION $(filter-out CVS,licenses/*) share/*.c share/*.h		\
+      VERSION licenses/* share/*.c share/*.h		                \
       share/libc/*.c share/libc/*.h share/libc/sys/*.h			\
-      share/libc/netinet/*.h share/acsl.el 				\
-      share/configure.ac share/Makefile.config.in			\
-      share/Makefile.common share/Makefile.plugin			\
-      share/Makefile.dynamic		                                \
+      share/libc/netinet/*.h share/acsl.el share/configure.ac		\
+      share/Makefile.config.in share/Makefile.common			\
+      share/Makefile.plugin share/Makefile.dynamic			\
       share/Makefile.dynamic_config.external				\
-      share/Makefile.dynamic_config.internal             		\
-      $(filter-out %kui%,src/kernel/*.ml*)		                \
-      external/hptmap.ml* external/unmarshal*.ml*			\
-      src/ai/*.ml* src/buckx/*.ml* src/buckx/*.c src/gui/*.ml*		\
-      src/lib/*.ml* src/logic/*.ml* src/memory_state/*.ml*		\
-      src/misc/*.ml* src/project/*.ml* src/toplevel/*.ml*		\
-      src/type/*.ml* bin/sed_get_make_major bin/sed_get_make_minor	\
-      bin/sed_inplace INSTALL INSTALL_WITH_WHY .make-clean		\
-      .make-clean-stamp .make-ocamlgraph-stamp
+      share/Makefile.dynamic_config.internal               		\
+      src/kernel/*.ml* external/hptmap.ml*			        \
+      external/unmarshal*.ml* external/unz.ml*                          \
+      src/ai/*.ml* src/buckx/*.ml*	                         	\
+      src/buckx/*.c src/gui/*.ml* src/logic/*.ml*                       \
+      $(filter-out src/lib/my_bigint.ml,$(wildcard src/lib/*.ml*))      \
+      src/memory_state/*.ml* src/misc/*.ml* src/project/*.ml*		\
+      src/toplevel/*.ml* src/type/*.ml* bin/sed_get_make_major		\
+      bin/sed_get_make_minor INSTALL INSTALL_WITH_WHY .make-clean	\
+      .make-clean-stamp .make-ocamlgraph-stamp				
+
+# files that are needed to compile API documentation of external plugins
+DOC_GEN_FILES:=$(addprefix doc/code/, \
+      *.css intro_plugin.txt intro_kernel_plugin.txt kernel-doc.ocamldoc \
+      docgen.cm* *.htm)
 
 ################
 # Main targets #
@@ -294,6 +335,23 @@
 BYTE_LIBS+=$(OCAMLVIZ_LIB_BYTE)
 OPT_LIBS+=$(OCAMLVIZ_LIB_OPT)
 
+#########
+# OUnit #
+#########
+
+USE_OUNIT_TOOL=no
+ifeq ($(USE_OUNIT_TOOL),yes)
+  OCAML_LIBDIR :=$(shell ocamlc -where)
+  OUNIT_PATH=$(OCAML_LIBDIR)/../pkg-lib/oUnit
+  OUNIT_COMPILER_BYTE=-I $(OUNIT_PATH)
+  OUNIT_COMPILER_OPT=-I $(OUNIT_PATH)
+  OUNIT_LIB_BYTE=$(OUNIT_PATH)/oUnit.cma
+  OUNIT_LIB_OPT=$(OUNIT_PATH)/oUnit.cmxa
+endif
+
+BYTE_LIBS+=$(OUNIT_LIB_BYTE)
+OPT_LIBS+=$(OUNIT_LIB_OPT)
+
 ##############
 # Ocamlgraph #
 ##############
@@ -309,72 +367,3 @@
 
 lib/graph.cmo: lib/graph.cmi
 	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@
-
-lib/graph.cmx: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@
-
-lib/graph.o: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@
-
-GENERATED+= lib/graph.cmo lib/graph.cmi
-ifneq ($(OCAMLOPT),no)
-GENERATED+= lib/graph.cmx lib/graph.o
-endif
-
-GRAPH_BYTE_LIBS=lib/graph.cmo
-GRAPH_OPT_LIBS=lib/graph.cmx
-GEN_BYTE_LIBS+=$(GRAPH_BYTE_LIBS)
-GEN_OPT_LIBS+=$(GRAPH_OPT_LIBS)
-
-.PRECIOUS: .cmo .cmi .cmx .o .cmxa .cma
-
-# viewgraph and  dgraph (included in ocamlgraph)
-ifeq ($(HAS_GNOMECANVAS),yes)
-
-lib/viewgraph.cmi: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@
-
-lib/viewgraph.cmo: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@
-
-lib/viewgraph.cmx: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@
-
-lib/viewgraph.o: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@
-
-lib/dgraph.cmi: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@
-
-lib/dgraph.cmo: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@
-
-lib/dgraph.cmx: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@
-
-lib/dgraph.o: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@
-
-GRAPH_GUICMO= lib/dgraph.cmo lib/viewgraph.cmo
-GRAPH_GUICMI= $(GRAPH_GUICMO:.cmo=.cmi)
-GRAPH_GUICMX= $(GRAPH_GUICMO:.cmo=.cmx)
-GRAPH_GUIO=  $(GRAPH_GUICMO:.cmo=.o)
-GENERATED+= $(GRAPH_GUICMI) $(GRAPH_GUICMO)
-ifneq ($(OCAMLOPT),no)
-GENERATED+= $(GRAPH_GUICMX) $(GRAPH_GUIO)
-endif
-
-GEN_BYTE_GUI_LIBS+=$(GRAPH_GUICMO)
-GEN_OPT_GUI_LIBS+=$(GRAPH_GUICMX)
-

=== src/dummy/hello_world/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2011                                               #
#    CEA (Commissariat  l'nergie atomique et aux nergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# Example of Makefile for dynamic plugins
#########################################

# Frama-c should be properly installed with "make install" 
# before any use of this makefile

FRAMAC_SHARE  	:=$(shell frama-c.byte -print-path)
FRAMAC_LIBDIR 	:=$(shell frama-c.byte -print-libpath)
PLUGIN_NAME	= Hello
PLUGIN_CMO	= hello_world
include $(FRAMAC_SHARE)/Makefile.dynamic

=== src/dummy/untyped_metrics/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2011                                               #
#    CEA (Commissariat  l'nergie atomique et aux nergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# Generic Makefile for bytecode plugins

FRAMAC_SHARE=$(shell frama-c -print-path)

PLUGIN_NAME=Untyped_metrics
PLUGIN_CMO=count_for

include $(FRAMAC_SHARE)/Makefile.dynamic

=== debian/changelog ===
frama-c (20111001+nitrogen+dfsg-4) unstable; urgency=low

  * Port to OCamlgraph 1.8.2
    - add 0007-Port-to-OCamlgraph-1.8.2.patch
  * Bump Standards-Version to 3.9.3, no changes needed

 -- Mehdi Dogguy <mehdi@debian.org>  Wed, 16 May 2012 14:58:29 +0200

frama-c (20111001+nitrogen+dfsg-3) unstable; urgency=low

  * Include patchlevel2 for Nitrogen 20111001.
    - add debian/patches/0006-Patchlevel2-for-Nitrogen-20111001.patch

 -- Mehdi Dogguy <mehdi@debian.org>  Fri, 06 Jan 2012 09:30:44 +0100

frama-c (20111001+nitrogen+dfsg-2) unstable; urgency=low

  * add 0005-Disable-CHMOD_RO-invocations.patch.

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 03 Jan 2012 15:24:55 +0100

frama-c (20111001+nitrogen+dfsg-1) unstable; urgency=low

  * New upstream release (Closes: #652257).
  * Update patches:
    - remove 0001-Value-Analysis-Carbon-patchlevel-1.patch
    - remove 0002-Fix-for-issue-727.patch
    - rebase 0003-Add-ocamlgraph-to-DYN_-O-B-LINKFLAGS.patch
    - update 0004-Accept-ocamlgraph-1.8.patch
    - add 0003-Fix-spelling-error-in-binary.patch
    - add 0004-Use-bin-cp-instead-of-usr-bin-install.patch
  * Bump minimum requirement for ocamlgraph to 1.8.
  * Bump Standards-Version to 3.9.2, no changes needed.

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 02 Jan 2012 17:29:13 +0100

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  libocamlgraph-viewer-ocaml-dev (>> 1.8~),
  liblablgtk2-gnome-ocaml-dev (>= 2.14.0+dfsg-2~),
  liblablgtksourceview2-ocaml-dev (>= 2.14.0+dfsg-2~)
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://frama-c.com/
 Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/frama-c.git
 Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/frama-c.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk

FRAMA_DIR=$(CURDIR)/debian/tmp

override_dh_auto_configure:
	mkdir -p lib/plugins
	mkdir -p lib/gui
	touch .depend .make-clean .make-clean-stamp
	[ ! -f src/kernel/config.ml ] || cp src/kernel/config.ml src/kernel/config.ml.debian
	./configure $(CROSS) --prefix=/usr       \
		--mandir=\$${prefix}/share/man   \
		--infodir=\$${prefix}/share/info \
		--datarootdir=\$${prefix}/share  \
		--disable-impact		 \
		--disable-security		 \
		--enable-verbosemake             \
		CFLAGS="$(CFLAGS)"               \
		LDFLAGS="-Wl,-z,defs"

override_dh_auto_install:
	$(MAKE) prefix=$(FRAMA_DIR)/usr FRAMAC_DATADIR=$(FRAMA_DIR)/usr/share/frama-c install
	# Fix permission of .c and .h files (they don't have to be executable)
	find debian/ -name "*.c" -or -name "*.h" -exec chmod a-x '{}' \;
	cp debian/icons/frama-c.svg $(CURDIR)/debian/frama-c/usr/share/icons/hicolor/scalable/apps/
	cp debian/icons/frama-c.xpm $(CURDIR)/debian/frama-c/usr/share/pixmaps/
	cp debian/frama-c.desktop $(CURDIR)/debian/frama-c/usr/share/applications/
	$(RM) -f $(CURDIR)/debian/frama-c/usr/bin/frama-c-gui.byte
	$(RM) -f $(CURDIR)/debian/frama-c/usr/bin/ptests.byte
	# Same file as frama-c.1. We use a symlink instead of copying the file twice
	$(RM) -f $(FRAMA_DIR)/usr/share/man/man1/frama-c-gui.1
ifeq ($(OCAML_OPT_ARCH),)
	$(RM) -f $(CURDIR)/debian/frama-c/usr/bin/frama-c.byte
endif

override_dh_auto_clean:
	touch .depend
	[ ! -f src/kernel/config.ml.debian ] || mv src/kernel/config.ml.debian src/kernel/config.ml
	[ ! -f Makefile -o ! -f share/Makefile.config ] || $(MAKE) clean
	$(RM) -rf lib .depend

%:
	dh --with ocaml $@

## frama-c 20130601%2Bfluorine3%2Bdfsg

=== doc/code/print_api/Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2013                                               #
#    CEA (Commissariat  l'nergie atomique et aux nergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# Print_api plugin
##################

# Frama-C should be properly installed with "make install"
# befor any use of this makefile

ifndef FRAMAC_SHARE
FRAMAC_SHARE	:=$(shell frama-c.byte -print-path)
endif
ifndef FRAMAC_LIBDIR
FRAMAC_LIBDIR	:=$(shell frama-c.byte -print-libpath)
endif

PLUGIN_DIR	?= .
PLUGIN_NAME	:= Print_api
PLUGIN_CMO	:= grammar lexer print_interface
PLUGIN_GENERATED:= $(PLUGIN_DIR)/grammar.ml $(PLUGIN_DIR)/grammar.mli \
		$(PLUGIN_DIR)/lexer.ml

include $(FRAMAC_SHARE)/Makefile.dynamic

clean:: 
	$(RM) $(Print_api_DIR)/dynamic_plugins.mli
	$(RM) $(Print_api_DIR)/grammar.output
	$(RM) $(Print_api_DIR)/grammar.ml
	$(RM) $(Print_api_DIR)/grammar.mli
	$(RM) $(Print_api_DIR)/lexer.ml
